unit Delphi4PythonMain;

interface
uses PythonEngine;

// for python 3.x
function PyInit_Delphi4Python : PPyObject; cdecl;


implementation
uses WrapDelphi, WrapDelphiVCL;

var
  gEngine : TPythonEngine;
  gModule : TPythonModule;
  gDelphiWrapper : TPyDelphiWrapper;

function PyInit_Delphi4Python : PPyObject;
begin
  try
    gEngine := TPythonEngine.Create(nil);
    gEngine.AutoFinalize := False;
    gEngine.UseLastKnownVersion := False;
    gEngine.RegVersion := '3.9';  //<-- Use the same version as the python 3.x your main program uses
    gEngine.DllName := 'python39.dll';
    gModule := TPythonModule.Create(nil);
    gModule.Engine := gEngine;
    gModule.ModuleName := 'Delphi4Python';
    gDelphiWrapper := TPyDelphiWrapper.Create(nil);  // no need to destroy
    gDelphiWrapper.Engine := gEngine;
    gDelphiWrapper.Module := gModule;
    gEngine.LoadDll;
  except
  end;
  Result := gModule.Module;
end;

initialization
finalization
  gEngine.Free;
  gModule.Free;
  gDelphiWrapper.Free;
end.


